#include <unistd.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <signal.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>

int main()
{
 pid_t pid;
 int fd[2];
 int mul5 = 0;
 int mul3 = 0;
 int byte = 0;
 int pass = 0;
 
 if(s_pipe(fd) < 0)
   printf("pipe error\n");

 pid = fork();
 if(pid > 0)
 {
	printf("I am parent\n");
	for(int i = 0; i < 25; i++)
	{
	  if((i % 5) == 0)
	     mul5++;
	  else 
	  {
		 printf("Writing to child : %i ", i);	  
		 write(fd[1],&i,1);
		 printf("and it has finish writing\n");
	  }
	  
	}
	printf("Multiply of 5 : %i\n", mul5);
    printf("Multiply of 3 : %i\n", mul3);
 }
 else if(pid == 0)
 {
    printf("I am child\n");
	byte = read(fd[0],&pass,1);
	printf("Getting msg from parent ");
	if(byte == 0)
	  printf("byte : %i\n", byte);
	else
	  printf("pass : %i\n", pass);
    if((pass % 3) == 0)
       mul3++;	
 } 
 else
   printf("Danger fork() has failed \n");

 exit(1);
}

